//============================亚博智能===========================
//  智能小车前后左右综合实验
//===============================================================
//#include <Servo.h> 
int Left_motor_back=9;       //左电机后退(IN1)
int Left_motor_go=5;         //左电机前进(IN2)

int Right_motor_go=6;        // 右电机前进(IN3)
int Right_motor_back=10;    // 右电机后退(IN4)

int Right_motor_en=8;      // 右电机前进(EN2)
int Left_motor_en=7;      // 左电机后退(EN1)


void setup()
{
  //初始化电机驱动IO为输出方式
  pinMode(Left_motor_go,OUTPUT); // PIN 8 (PWM)
  pinMode(Left_motor_back,OUTPUT); // PIN 9 (PWM)
  pinMode(Right_motor_go,OUTPUT);// PIN 10 (PWM) 
  pinMode(Right_motor_back,OUTPUT);// PIN 11 (PWM)


 
}
void run(int time)     // 前进
{
  digitalWrite(Left_motor_en,HIGH);  // 左电机使能
  digitalWrite(Right_motor_en,HIGH);  // 右电机使能
  
  digitalWrite(Right_motor_go,HIGH);  // 右电机前进 6 in3 1
  digitalWrite(Right_motor_back,LOW);  //10 in4 0   
  analogWrite(Right_motor_go,200);//PWM比例0~255调速，左右轮差异略增减
  //analogWrite(Right_motor_back,0);//5.8v  
  digitalWrite(Left_motor_go,HIGH);  // 左电机前进 5 in2 1
  digitalWrite(Left_motor_back,LOW);// 9 in1 0
  analogWrite(Left_motor_go,200);//PWM比例0~255调速，左右轮差异略增减
  //analogWrite(Left_motor_back,0);
  delay(time * 100);   //执行时间，可以调整  毫秒级
}

void brake(int time)         //刹车，停车
{
  digitalWrite(Right_motor_go,LOW);//6  0
  digitalWrite(Right_motor_back,LOW);//10  0
  digitalWrite(Left_motor_go,LOW);//5   0
  digitalWrite(Left_motor_back,LOW);//9   0
  delay(time * 100);//执行时间，可以调整  
}

void left(int time)         //左转(左轮不动，右轮前进)
{
  digitalWrite(Right_motor_go,HIGH);	// 右电机前进6 in3 1
  digitalWrite(Right_motor_back,LOW);//10 in4 0
  analogWrite(Right_motor_go,200); // 78%
  //analogWrite(Right_motor_back,0);//PWM比例0~255调速
  digitalWrite(Left_motor_go,LOW);   //左轮不动
  digitalWrite(Left_motor_back,LOW);
  analogWrite(Left_motor_go,0); 
  //analogWrite(Left_motor_back,0);//PWM比例0~255调速
  delay(time * 100);	//执行时间，可以调整  
}

void spin_left(int time)         //左转(左轮后退，右轮前进)
{
  digitalWrite(Right_motor_go,HIGH);	// 右电机前进 6 1
  digitalWrite(Right_motor_back,LOW);//10 0
  analogWrite(Right_motor_go,200); 
  analogWrite(Right_motor_back,0);//PWM比例0~255调速
  digitalWrite(Left_motor_go,LOW);   //左轮后退5 0
  digitalWrite(Left_motor_back,HIGH);//9 1
  analogWrite(Left_motor_go,0); 
  analogWrite(Left_motor_back,200);//PWM比例0~255调速
  delay(time * 100);	//执行时间，可以调整  
}

void right(int time)        //右转(右轮不动，左轮前进)
{
  digitalWrite(Right_motor_go,LOW);   //右电机不动  6  0
  digitalWrite(Right_motor_back,LOW);//10 0
  analogWrite(Right_motor_go,0); 
  analogWrite(Right_motor_back,0);//PWM比例0~255调速
  digitalWrite(Left_motor_go,HIGH);//左电机前进 5 1
  digitalWrite(Left_motor_back,LOW);// 9 0
  analogWrite(Left_motor_go,200); 
  analogWrite(Left_motor_back,0);//PWM比例0~255调速
  delay(time * 100);	//执行时间，可以调整  
}

void spin_right(int time)        //右转(右轮后退，左轮前进)
{
  digitalWrite(Right_motor_go,LOW);   //右电机后退6 0
  digitalWrite(Right_motor_back,HIGH);// 10 1
  analogWrite(Right_motor_go,0); 
  analogWrite(Right_motor_back,200);//PWM比例0~255调速
  digitalWrite(Left_motor_go,HIGH);//左电机前进5 1
  digitalWrite(Left_motor_back,LOW);//9 0
  analogWrite(Left_motor_go,200); 
  analogWrite(Left_motor_back,0);//PWM比例0~255调速
  delay(time * 100);	//执行时间，可以调整  
}

void back(int time)          //后退
{
  digitalWrite(Right_motor_go,LOW);  //右轮后退6 0
  digitalWrite(Right_motor_back,HIGH);//10 1
  analogWrite(Right_motor_go,0);
  analogWrite(Right_motor_back,150);//PWM比例0~255调速
  digitalWrite(Left_motor_go,LOW);  //左轮后退
  digitalWrite(Left_motor_back,HIGH);
  analogWrite(Left_motor_go,0);
  analogWrite(Left_motor_back,150);//PWM比例0~255调速
  delay(time * 100);     //执行时间，可以调整  
}

void loop()
{


       delay(2000); //延时2s后启动
       back(10); //后退1s
       brake(5);//停止0.5s
       run(10);//前进1s
       brake(5);//停止0.5s
       left(10);//向左转1s
       right(10);//向右转1s
       spin_right(20); //向右旋转2s
       spin_left(20);//向左旋转2s
       brake(5);//停车 0.5ss  

}


